package com.minemaarten.signals.tileentity;

import java.util.Objects;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.math.BlockPos;

import com.minemaarten.signals.block.BlockRailLink;
import com.minemaarten.signals.network.GuiSynced;
import com.minemaarten.signals.rail.network.NetworkRail;
import com.minemaarten.signals.rail.network.mc.MCPos;
import com.minemaarten.signals.rail.network.mc.RailNetworkManager;

public class TileEntityRailLink extends TileEntityBase implements IGUIButtonSensitive{
    private MCPos linkedPos;
    @GuiSynced
    private int holdDelay;

    public MCPos getLinkedPosition(){
        return linkedPos;
    }

    public void setLinkedPos(MCPos railPos){
        if(!Objects.equals(railPos, linkedPos)) {
            linkedPos = railPos;
            RailNetworkManager.getInstance().markDirty(getMCPos());
            updateLinkState();
        }
    }

    private void updateLinkState(){
        NetworkRail<MCPos> linkedRail = linkedPos == null ? null : RailNetworkManager.getInstance().getRail(linkedPos);
        field_145850_b.func_180501_a(func_174877_v(), field_145850_b.func_180495_p(func_174877_v()).func_177226_a(BlockRailLink.CONNECTED, linkedRail != null), 2);
    }

    @Override
    public void handleGUIButtonPress(EntityPlayer player, int... data){
        if(data[0] != holdDelay) {
            holdDelay = data[0];
            RailNetworkManager.getInstance().markDirty(getMCPos());
        }
    }

    public int getHoldDelay(){
        return holdDelay;
    }

    @Override
    public NBTTagCompound func_189515_b(NBTTagCompound tag){
        if(linkedPos != null) {
            tag.func_74768_a("linkedX", linkedPos.getX());
            tag.func_74768_a("linkedY", linkedPos.getY());
            tag.func_74768_a("linkedZ", linkedPos.getZ());
            tag.func_74768_a("linkedDim", linkedPos.getDimID());
        }

        tag.func_74768_a("holdDelay", holdDelay);
        return super.func_189515_b(tag);
    }

    @Override
    public void func_145839_a(NBTTagCompound tag){
        if(tag.func_74764_b("linkedX")) {
            BlockPos p = new BlockPos(tag.func_74762_e("linkedX"), tag.func_74762_e("linkedY"), tag.func_74762_e("linkedZ"));
            linkedPos = new MCPos(tag.func_74762_e("linkedDim"), p);
        } else {
            linkedPos = null;
        }

        holdDelay = tag.func_74762_e("holdDelay");
        super.func_145839_a(tag);
    }
}
